import os
from datetime import datetime
from dotenv import load_dotenv
load_dotenv()

class LinkObj(object):
    def __init__(self, objtype, mailbox, batchid, size, batchfile, currentdate, flags, formats, orgname, download=False):
        ordn = None
        bf = 0
        filetype = "RECEIVE"
        factory = "INJ"

        if os.getenv('YAZAKI_TYPE') == 'RMW':
            ordn = str(batchfile).strip()
            factory = "RMW"
            filename = ""
            if ordn[:3] == "OES":
                filename = ordn[len("OES.32TE.SPL."):]
            else:
                filename = ordn[len("NRRIS.32TE.SPL."):]

            filename =  filename[:filename.find(".")].upper()
            if filename == "ISSUELIST":
                filetype = "CONLOT"

            elif filename == "ISSUENO":
                filetype = "KANBAN"

            else:
                filetype = "RECEIVE"



        elif os.getenv('YAZAKI_TYPE') == 'CK':
            ordn = str(batchfile[:len("OES.VCBI")]).strip()
            bf = int(str(batchfile[len("OES.VCBI") + 3:])[1:2].strip())
            filetype = "RECEIVE"
            if ordn == "OES.VCBI":
                filetype = "ORDERPLAN"

            factory = "INJ"
            if bf == 4:
                factory = "AW"

        elif os.getenv('YAZAKI_TYPE') == 'J03':
            print("J03")

        elif os.getenv('YAZAKI_TYPE') == 'FG':
            print("FG")

        else:
            print("UNKNOW")

        self.objtype     = objtype
        self.mailbox     = mailbox
        self.batchid     = batchid
        self.size        = size
        self.batchfile   = batchfile
        self.currentdate = datetime.strptime(currentdate, '%b %d, %Y %I:%M %p')
        self.flags       = flags
        self.formats     = formats
        self.orgname     = orgname
        self.factory     = factory
        self.filetype    = filetype
        self.download    = download

    def linkfile(self):
        return f"https://{os.getenv('HOST')}:{os.getenv('PORT')}/cehttp/servlet/MailboxServlet?operation=DOWNLOAD&mailbox_id={self.mailbox}&batch_num={self.batchid}&data_format=A&batch_id={self.batchfile}"